<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::TestableAttachmentWriter Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer.html">TestableAttachmentWriter</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::TestableAttachmentWriter Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_testable_attachment_writer_8h_source.html">TestableAttachmentWriter.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::avsCommon::utils::TestableAttachmentWriter:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer_inherit__map" id="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html" title="alexaClientSDK::avsCommon\l::avs::attachment::InProcessAttachment\lWriter" alt="" coords="5,92,262,144"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html" title="alexaClientSDK::avsCommon\l::avs::attachment::AttachmentWriter" alt="" coords="17,5,250,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<div class="dynheader">
Collaboration diagram for alexaClientSDK::avsCommon::utils::TestableAttachmentWriter:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer__coll__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer_coll__map" alt="Collaboration graph"/></div>
<map name="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer_coll__map" id="alexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer_coll__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html" title="alexaClientSDK::avsCommon\l::avs::attachment::InProcessAttachment\lWriter" alt="" coords="5,92,262,144"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html" title="alexaClientSDK::avsCommon\l::avs::attachment::AttachmentWriter" alt="" coords="17,5,250,44"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a7625f5950dba1ed2df97ddf2bee13c36"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer.html#a7625f5950dba1ed2df97ddf2bee13c36">TestableAttachmentWriter</a> (std::shared_ptr&lt; <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a269866d267e8991328744c2e662931d2">avsCommon::utils::sds::InProcessSDS</a> &gt; dummySDS, std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">avsCommon::avs::attachment::AttachmentWriter</a> &gt; writer)</td></tr>
<tr class="separator:a7625f5950dba1ed2df97ddf2bee13c36"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aac0c87182c1d404adf4bfa831fdea727"><td class="memItemLeft" align="right" valign="top">std::size_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer.html#aac0c87182c1d404adf4bfa831fdea727">write</a> (const void *buf, std::size_t numBytes, <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86">WriteStatus</a> *writeStatus, std::chrono::milliseconds timeout) override</td></tr>
<tr class="separator:aac0c87182c1d404adf4bfa831fdea727"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e071604b0ed1681fddcddea6c2bc284"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1_testable_attachment_writer.html#a8e071604b0ed1681fddcddea6c2bc284">close</a> () override</td></tr>
<tr class="separator:a8e071604b0ed1681fddcddea6c2bc284"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachmentWriter</a></td></tr>
<tr class="memitem:a033e2014398ee7d2828832234a10e987 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a033e2014398ee7d2828832234a10e987">~InProcessAttachmentWriter</a> ()</td></tr>
<tr class="separator:a033e2014398ee7d2828832234a10e987 inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">alexaClientSDK::avsCommon::avs::attachment::AttachmentWriter</a></td></tr>
<tr class="memitem:a0a319d4be34eda95316c79dddf66063d inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a0a319d4be34eda95316c79dddf66063d">~AttachmentWriter</a> ()=default</td></tr>
<tr class="separator:a0a319d4be34eda95316c79dddf66063d inherit pub_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachmentWriter</a></td></tr>
<tr class="memitem:a2824dc07990ff4d1beffdbb4bcad89d0 inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a2824dc07990ff4d1beffdbb4bcad89d0">SDSType</a> = <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a269866d267e8991328744c2e662931d2">avsCommon::utils::sds::InProcessSDS</a></td></tr>
<tr class="memdesc:a2824dc07990ff4d1beffdbb4bcad89d0 inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="mdescLeft">&#160;</td><td class="mdescRight">Type aliases for convenience.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a2824dc07990ff4d1beffdbb4bcad89d0">More...</a><br /></td></tr>
<tr class="separator:a2824dc07990ff4d1beffdbb4bcad89d0 inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f1afed527c39e403331a65e7c6060bb inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memItemLeft" align="right" valign="top">using&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a9f1afed527c39e403331a65e7c6060bb">SDSTypeWriter</a> = <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds_1_1_shared_data_stream_1_1_writer.html">SDSType::Writer</a></td></tr>
<tr class="separator:a9f1afed527c39e403331a65e7c6060bb inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">alexaClientSDK::avsCommon::avs::attachment::AttachmentWriter</a></td></tr>
<tr class="memitem:a81b93cbd38af8b85c587c72e69cd0d86 inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86">WriteStatus</a> { <br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86ae0aa021e21dddbd6d8cecec71e9cf564">WriteStatus::OK</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86a110ccf2f5d2ff4eda1fd1a494293467d">WriteStatus::CLOSED</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86a20dda40fa5d3942e2c6eb9760a9d1602">WriteStatus::OK_BUFFER_FULL</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86aa1238e1a739964feb62763f7bf0875f0">WriteStatus::ERROR_BYTES_LESS_THAN_WORD_SIZE</a>, 
<br />
&#160;&#160;<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86a7b6311615dfbbaccec8279677f19feea">WriteStatus::ERROR_INTERNAL</a>, 
<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86ac5b306a30b21dec5abcb84067152687a">WriteStatus::TIMEDOUT</a>
<br />
 }</td></tr>
<tr class="separator:a81b93cbd38af8b85c587c72e69cd0d86 inherit pub_types_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_static_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td colspan="2" onclick="javascript:toggleInherit('pub_static_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer')"><img src="closed.png" alt="-"/>&#160;Static Public Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachmentWriter</a></td></tr>
<tr class="memitem:a725fb4e821ced54aacd2599cd7cbbca4 inherit pub_static_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html">InProcessAttachmentWriter</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a725fb4e821ced54aacd2599cd7cbbca4">create</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a2824dc07990ff4d1beffdbb4bcad89d0">SDSType</a> &gt; sds, <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">SDSTypeWriter::Policy</a> policy=SDSTypeWriter::Policy::ALL_OR_NOTHING)</td></tr>
<tr class="separator:a725fb4e821ced54aacd2599cd7cbbca4 inherit pub_static_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td colspan="2" onclick="javascript:toggleInherit('pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer')"><img src="closed.png" alt="-"/>&#160;Protected Member Functions inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachmentWriter</a></td></tr>
<tr class="memitem:a0d09297852aeece04b7a1bd1d43f725a inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a0d09297852aeece04b7a1bd1d43f725a">InProcessAttachmentWriter</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a2824dc07990ff4d1beffdbb4bcad89d0">SDSType</a> &gt; sds, <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a7b17d768f16a6f5da766df780d94bbd5">SDSTypeWriter::Policy</a> policy=SDSTypeWriter::Policy::ALL_OR_NOTHING)</td></tr>
<tr class="separator:a0d09297852aeece04b7a1bd1d43f725a inherit pro_methods_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td colspan="2" onclick="javascript:toggleInherit('pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer')"><img src="closed.png" alt="-"/>&#160;Protected Attributes inherited from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachmentWriter</a></td></tr>
<tr class="memitem:a36be06317d26cbc2c2f8b21093c01a3f inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memItemLeft" align="right" valign="top">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a9f1afed527c39e403331a65e7c6060bb">SDSTypeWriter</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a36be06317d26cbc2c2f8b21093c01a3f">m_writer</a></td></tr>
<tr class="memdesc:a36be06317d26cbc2c2f8b21093c01a3f inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="mdescLeft">&#160;</td><td class="mdescRight">The underlying <code>SharedDataStream</code> reader.  <a href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a36be06317d26cbc2c2f8b21093c01a3f">More...</a><br /></td></tr>
<tr class="separator:a36be06317d26cbc2c2f8b21093c01a3f inherit pro_attribs_classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">A version of the Decorator Pattern, this class allows us to simulate pausing writes without requiring an actual (slow) AttachmentReader anywhere in the test code. Besides this small change in functionality, all real work is done by the encapsulated InProcessAttachmentWriter object. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a7625f5950dba1ed2df97ddf2bee13c36"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7625f5950dba1ed2df97ddf2bee13c36">&#9670;&nbsp;</a></span>TestableAttachmentWriter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::utils::TestableAttachmentWriter::TestableAttachmentWriter </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1sds.html#a269866d267e8991328744c2e662931d2">avsCommon::utils::sds::InProcessSDS</a> &gt;&#160;</td>
          <td class="paramname"><em>dummySDS</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html">avsCommon::avs::attachment::AttachmentWriter</a> &gt;&#160;</td>
          <td class="paramname"><em>writer</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dummySDS</td><td>An SDS used to instantiate this class, although it will never be used. This is to avert any risk of this wrapper object being created with a nullptr. </td></tr>
    <tr><td class="paramname">writer</td><td>The AttachmentWriter object to be wrapped by this class. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a8e071604b0ed1681fddcddea6c2bc284"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8e071604b0ed1681fddcddea6c2bc284">&#9670;&nbsp;</a></span>close()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::TestableAttachmentWriter::close </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">The close function. An implementation will take care of any resource management when a writer no longer needs to use an attachment. </p>

<p>Reimplemented from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a5d94c5c5783daddbc0de788780b8e6bd">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachmentWriter</a>.</p>

</div>
</div>
<a id="aac0c87182c1d404adf4bfa831fdea727"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aac0c87182c1d404adf4bfa831fdea727">&#9670;&nbsp;</a></span>write()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::size_t alexaClientSDK::avsCommon::utils::TestableAttachmentWriter::write </td>
          <td>(</td>
          <td class="paramtype">const void *&#160;</td>
          <td class="paramname"><em>buf</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::size_t&#160;</td>
          <td class="paramname"><em>numBytes</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_attachment_writer.html#a81b93cbd38af8b85c587c72e69cd0d86">WriteStatus</a> *&#160;</td>
          <td class="paramname"><em>writeStatus</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">std::chrono::milliseconds&#160;</td>
          <td class="paramname"><em>timeout</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">override</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">The write function.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">buf</td><td>The buffer where data should be copied from. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">numBytes</td><td>The size of the buffer in bytes. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">writeStatus</td><td>The out-parameter where the resulting state of the write will be expressed. </td></tr>
    <tr><td class="paramdir"></td><td class="paramname">timeout</td><td>The maximum time to wait (if <code>policy</code> is <code>BLOCKING</code>) for space to write into. If this parameter is zero, there is no timeout and blocking writes will wait forever. If <code>policy</code> is not  BLOCKING, this parameter is ignored. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The number of bytes written as a result of this call. </dd></dl>

<p>Reimplemented from <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1attachment_1_1_in_process_attachment_writer.html#a5d846aac2260fae7a3bd4f14d4ec01c0">alexaClientSDK::avsCommon::avs::attachment::InProcessAttachmentWriter</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/test/AVSCommon/Utils/Common/<a class="el" href="_testable_attachment_writer_8h_source.html">TestableAttachmentWriter.h</a></li>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/test/Common/<a class="el" href="_testable_attachment_writer_8cpp.html">TestableAttachmentWriter.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
